import * as React from 'react';
import { BaseEditor } from 'slate';
import { ReactEditor } from 'slate-react';
type CustomElement = {
    type: 'text' | 'completion' | undefined;
    children: CustomText[];
};
type CustomText = {
    text: string;
    type: undefined;
};
type CustomDescendant = CustomElement | CustomText;
type CEditor = Omit<BaseEditor, 'children'> & ReactEditor & {
    children: CustomDescendant[];
};
declare module 'slate' {
    interface CustomTypes {
        Editor: CEditor;
        Element: CustomElement;
        Text: CustomText;
    }
}
export interface SmartInputProps {
    modelId: string;
    value: string;
    onChange: (newValue: string) => void;
    renderText: (props: any) => React.ReactElement;
    renderSuggestion: (props: any) => React.ReactElement;
    className?: string;
    multiline?: boolean;
    onBlur?: React.FocusEventHandler<HTMLDivElement>;
    onFocus?: React.FocusEventHandler<HTMLDivElement>;
    onKeyDown?: React.KeyboardEventHandler<HTMLDivElement>;
    placeholder?: string;
    style?: React.CSSProperties;
    apiEndpoint?: string;
}
export declare function SmartInput(props: SmartInputProps): JSX.Element;
export {};
